#!/usr/bin/perl -w

use strict;
use Socket;   # For host name lookups

my $os = `uname`;
chomp($os);

my ($cmd, $ipStr, $macStr);

if ($os =~ /SunOS/)
{
  $cmd = '/sbin/ifconfig -a';
  $ipStr = 'inet';
  $macStr = 'ether';
}
else
{
  $cmd = '/sbin/ifconfig';
  $ipStr = 'inet addr:';
  $macStr = 'HWaddr';
}

my $res = `$cmd`;
my ($ip, $mac, $host) = ('', '', '');
foreach my $line (split(/\n/, $res))
{
  if ($line =~ /$ipStr/)
  {
    ($ip) = ($line =~ /$ipStr\s*(\S+)/);
    $ip = '' if (!defined($ip) || ($ip eq '127.0.0.1'));
  }
  if ($line =~ /$macStr/)
  {
    ($mac) = ($line =~ /$macStr\s+(\S+)/);
    $mac = '' if (!defined($mac));
  }
  last if (($ip ne '') && ($mac ne ''));
}

if ($ip ne '')
{
  $host = gethostbyaddr(inet_aton($ip), AF_INET) || '';
}

print "MAC=$mac\nIP=$ip\nHOST=$host\n";
